// Code generated by lark_sdk_gen. DO NOT EDIT.
/**
 * Copyright 2022 chyroc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package lark

import (
	"context"
)

// BatchGetAttendanceUserFlow 批量查询授权内员工的实际打卡流水记录。例如, 企业给一个员工设定的班次是上午 9 点和下午 6 点各打一次上下班卡, 但是该员工在这期间打了多次卡, 该接口会把所有的打卡记录都返回。
//
// 如果只需获取打卡结果, 而不需要详细的打卡数据, 可使用“获取打卡结果”的接口。
//
// doc: https://open.feishu.cn/document/uAjLw4CM/ukTMukTMukTM/reference/attendance-v1/user_flow/query
func (r *AttendanceService) BatchGetAttendanceUserFlow(ctx context.Context, request *BatchGetAttendanceUserFlowReq, options ...MethodOptionFunc) (*BatchGetAttendanceUserFlowResp, *Response, error) {
	if r.cli.mock.mockAttendanceBatchGetAttendanceUserFlow != nil {
		r.cli.log(ctx, LogLevelDebug, "[lark] Attendance#BatchGetAttendanceUserFlow mock enable")
		return r.cli.mock.mockAttendanceBatchGetAttendanceUserFlow(ctx, request, options...)
	}

	req := &RawRequestReq{
		Scope:                 "Attendance",
		API:                   "BatchGetAttendanceUserFlow",
		Method:                "POST",
		URL:                   r.cli.openBaseURL + "/open-apis/attendance/v1/user_flows/query",
		Body:                  request,
		MethodOption:          newMethodOption(options),
		NeedTenantAccessToken: true,
	}
	resp := new(batchGetAttendanceUserFlowResp)

	response, err := r.cli.RawRequest(ctx, req, resp)
	return resp.Data, response, err
}

// MockAttendanceBatchGetAttendanceUserFlow mock AttendanceBatchGetAttendanceUserFlow method
func (r *Mock) MockAttendanceBatchGetAttendanceUserFlow(f func(ctx context.Context, request *BatchGetAttendanceUserFlowReq, options ...MethodOptionFunc) (*BatchGetAttendanceUserFlowResp, *Response, error)) {
	r.mockAttendanceBatchGetAttendanceUserFlow = f
}

// UnMockAttendanceBatchGetAttendanceUserFlow un-mock AttendanceBatchGetAttendanceUserFlow method
func (r *Mock) UnMockAttendanceBatchGetAttendanceUserFlow() {
	r.mockAttendanceBatchGetAttendanceUserFlow = nil
}

// BatchGetAttendanceUserFlowReq ...
type BatchGetAttendanceUserFlowReq struct {
	EmployeeType          EmployeeType `query:"employee_type" json:"-"`           // 请求体中的 user_ids 和响应体中的 user_id 的员工工号类型, 示例值: "employee_id", 可选值有: employee_id: 员工 employee ID, 即飞书管理后台 > 组织架构 > 成员与部门 > 成员详情中的用户 ID, employee_no: 员工工号, 即飞书管理后台 > 组织架构 > 成员与部门 > 成员详情中的工号
	IncludeTerminatedUser *bool        `query:"include_terminated_user" json:"-"` // 由于新入职用户可以复用已离职用户的employee_no/employee_id。如果true, 返回employee_no/employee_id对应的所有在职+离职用户数据；如果false, 只返回employee_no/employee_id对应的在职或最近一个离职用户数据, 示例值: true
	UserIDs               []string     `json:"user_ids,omitempty"`                // employee_no 或 employee_id 列表, 长度不超过 50, 示例值: [ "abd754f7"]
	CheckTimeFrom         string       `json:"check_time_from,omitempty"`         // 查询的起始时间, 时间戳, 示例值: "1566641088"
	CheckTimeTo           string       `json:"check_time_to,omitempty"`           // 查询的结束时间, 时间戳, 示例值: "1566641088"
}

// BatchGetAttendanceUserFlowResp ...
type BatchGetAttendanceUserFlowResp struct {
	UserFlowResults []*BatchGetAttendanceUserFlowRespUserFlowResult `json:"user_flow_results,omitempty"` // 打卡记录列表
}

// BatchGetAttendanceUserFlowRespUserFlowResult ...
type BatchGetAttendanceUserFlowRespUserFlowResult struct {
	UserID       string   `json:"user_id,omitempty"`       // 用户 ID
	CreatorID    string   `json:"creator_id,omitempty"`    // 记录创建者 ID
	LocationName string   `json:"location_name,omitempty"` // 打卡位置名称信息
	CheckTime    string   `json:"check_time,omitempty"`    // 打卡时间, 精确到秒的时间戳
	Comment      string   `json:"comment,omitempty"`       // 打卡备注
	RecordID     string   `json:"record_id,omitempty"`     // 打卡记录 ID
	Ssid         string   `json:"ssid,omitempty"`          // 打卡 Wi-Fi 的 SSID
	Bssid        string   `json:"bssid,omitempty"`         // 打卡 Wi-Fi 的 MAC 地址
	IsField      bool     `json:"is_field,omitempty"`      // 是否为外勤打卡
	IsWifi       bool     `json:"is_wifi,omitempty"`       // 是否为 Wi-Fi 打卡
	Type         int64    `json:"type,omitempty"`          // 记录生成方式, 可选值有: 0: 用户打卡, 1: 管理员修改, 2: 用户补卡, 3: 系统自动生成, 4: 下班免打卡, 5: 考勤机, 6: 极速打卡, 7: 考勤开放平台导入
	PhotoURLs    []string `json:"photo_urls,omitempty"`    // 打卡照片列表
	CheckResult  string   `json:"check_result,omitempty"`  // 打卡结果, 可选值有: NoNeedCheck: 无需打卡, SystemCheck: 系统打卡, Normal: 正常, Early: 早退, Late: 迟到, SeriousLate: 严重迟到, Lack: 缺卡, Invalid: 无效, None: 无状态, Todo: 尚未打卡
}

// batchGetAttendanceUserFlowResp ...
type batchGetAttendanceUserFlowResp struct {
	Code int64                           `json:"code,omitempty"` // 错误码, 非 0 表示失败
	Msg  string                          `json:"msg,omitempty"`  // 错误描述
	Data *BatchGetAttendanceUserFlowResp `json:"data,omitempty"`
}
