// Code generated by lark_sdk_gen. DO NOT EDIT.
/**
 * Copyright 2022 chyroc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package lark

import (
	"context"
)

// DeleteContactUnit 使用该接口删除单位, 需要有更新单位的权限。注意: 如果单位的单位类型被其它的业务使用, 不允许删除。
//
// doc: https://open.feishu.cn/document/uAjLw4CM/ukTMukTMukTM/reference/contact-v3/unit/delete
func (r *ContactService) DeleteContactUnit(ctx context.Context, request *DeleteContactUnitReq, options ...MethodOptionFunc) (*DeleteContactUnitResp, *Response, error) {
	if r.cli.mock.mockContactDeleteContactUnit != nil {
		r.cli.log(ctx, LogLevelDebug, "[lark] Contact#DeleteContactUnit mock enable")
		return r.cli.mock.mockContactDeleteContactUnit(ctx, request, options...)
	}

	req := &RawRequestReq{
		Scope:                 "Contact",
		API:                   "DeleteContactUnit",
		Method:                "DELETE",
		URL:                   r.cli.openBaseURL + "/open-apis/contact/v3/unit/:unit_id",
		Body:                  request,
		MethodOption:          newMethodOption(options),
		NeedTenantAccessToken: true,
	}
	resp := new(deleteContactUnitResp)

	response, err := r.cli.RawRequest(ctx, req, resp)
	return resp.Data, response, err
}

// MockContactDeleteContactUnit mock ContactDeleteContactUnit method
func (r *Mock) MockContactDeleteContactUnit(f func(ctx context.Context, request *DeleteContactUnitReq, options ...MethodOptionFunc) (*DeleteContactUnitResp, *Response, error)) {
	r.mockContactDeleteContactUnit = f
}

// UnMockContactDeleteContactUnit un-mock ContactDeleteContactUnit method
func (r *Mock) UnMockContactDeleteContactUnit() {
	r.mockContactDeleteContactUnit = nil
}

// DeleteContactUnitReq ...
type DeleteContactUnitReq struct {
	UnitID string `path:"unit_id" json:"-"` // 单位ID, 示例值: "BU121"
}

// DeleteContactUnitResp ...
type DeleteContactUnitResp struct {
}

// deleteContactUnitResp ...
type deleteContactUnitResp struct {
	Code int64                  `json:"code,omitempty"` // 错误码, 非 0 表示失败
	Msg  string                 `json:"msg,omitempty"`  // 错误描述
	Data *DeleteContactUnitResp `json:"data,omitempty"`
}
