// Code generated by lark_sdk_gen. DO NOT EDIT.
/**
 * Copyright 2022 chyroc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package lark

import (
	"context"
)

// UpdateContactUnit 调用该接口, 需要有更新单位的权限。注意: 单位功能属于旗舰版付费功能, 企业需开通对应版本才可以修改单位
//
// doc: https://open.feishu.cn/document/uAjLw4CM/ukTMukTMukTM/reference/contact-v3/unit/patch
func (r *ContactService) UpdateContactUnit(ctx context.Context, request *UpdateContactUnitReq, options ...MethodOptionFunc) (*UpdateContactUnitResp, *Response, error) {
	if r.cli.mock.mockContactUpdateContactUnit != nil {
		r.cli.log(ctx, LogLevelDebug, "[lark] Contact#UpdateContactUnit mock enable")
		return r.cli.mock.mockContactUpdateContactUnit(ctx, request, options...)
	}

	req := &RawRequestReq{
		Scope:                 "Contact",
		API:                   "UpdateContactUnit",
		Method:                "PATCH",
		URL:                   r.cli.openBaseURL + "/open-apis/contact/v3/unit/:unit_id",
		Body:                  request,
		MethodOption:          newMethodOption(options),
		NeedTenantAccessToken: true,
	}
	resp := new(updateContactUnitResp)

	response, err := r.cli.RawRequest(ctx, req, resp)
	return resp.Data, response, err
}

// MockContactUpdateContactUnit mock ContactUpdateContactUnit method
func (r *Mock) MockContactUpdateContactUnit(f func(ctx context.Context, request *UpdateContactUnitReq, options ...MethodOptionFunc) (*UpdateContactUnitResp, *Response, error)) {
	r.mockContactUpdateContactUnit = f
}

// UnMockContactUpdateContactUnit un-mock ContactUpdateContactUnit method
func (r *Mock) UnMockContactUpdateContactUnit() {
	r.mockContactUpdateContactUnit = nil
}

// UpdateContactUnitReq ...
type UpdateContactUnitReq struct {
	UnitID string  `path:"unit_id" json:"-"` // 单位ID, 示例值: "BU121"
	Name   *string `json:"name,omitempty"`   // 单位的名字, 示例值: "消费者事业部"
}

// UpdateContactUnitResp ...
type UpdateContactUnitResp struct {
}

// updateContactUnitResp ...
type updateContactUnitResp struct {
	Code int64                  `json:"code,omitempty"` // 错误码, 非 0 表示失败
	Msg  string                 `json:"msg,omitempty"`  // 错误描述
	Data *UpdateContactUnitResp `json:"data,omitempty"`
}
