// Code generated by lark_sdk_gen. DO NOT EDIT.
/**
 * Copyright 2022 chyroc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package lark

import (
	"context"
)

// CreateMailUserMailboxAlias 创建用户邮箱别名
//
// doc: https://open.feishu.cn/document/uAjLw4CM/ukTMukTMukTM/reference/mail-v1/user_mailbox-alias/create
func (r *MailService) CreateMailUserMailboxAlias(ctx context.Context, request *CreateMailUserMailboxAliasReq, options ...MethodOptionFunc) (*CreateMailUserMailboxAliasResp, *Response, error) {
	if r.cli.mock.mockMailCreateMailUserMailboxAlias != nil {
		r.cli.log(ctx, LogLevelDebug, "[lark] Mail#CreateMailUserMailboxAlias mock enable")
		return r.cli.mock.mockMailCreateMailUserMailboxAlias(ctx, request, options...)
	}

	req := &RawRequestReq{
		Scope:                 "Mail",
		API:                   "CreateMailUserMailboxAlias",
		Method:                "POST",
		URL:                   r.cli.openBaseURL + "/open-apis/mail/v1/user_mailboxes/:user_mailbox_id/aliases",
		Body:                  request,
		MethodOption:          newMethodOption(options),
		NeedTenantAccessToken: true,
	}
	resp := new(createMailUserMailboxAliasResp)

	response, err := r.cli.RawRequest(ctx, req, resp)
	return resp.Data, response, err
}

// MockMailCreateMailUserMailboxAlias mock MailCreateMailUserMailboxAlias method
func (r *Mock) MockMailCreateMailUserMailboxAlias(f func(ctx context.Context, request *CreateMailUserMailboxAliasReq, options ...MethodOptionFunc) (*CreateMailUserMailboxAliasResp, *Response, error)) {
	r.mockMailCreateMailUserMailboxAlias = f
}

// UnMockMailCreateMailUserMailboxAlias un-mock MailCreateMailUserMailboxAlias method
func (r *Mock) UnMockMailCreateMailUserMailboxAlias() {
	r.mockMailCreateMailUserMailboxAlias = nil
}

// CreateMailUserMailboxAliasReq ...
type CreateMailUserMailboxAliasReq struct {
	UserMailboxID string  `path:"user_mailbox_id" json:"-"` // 用户邮箱地址, 示例值: "user@xxx.xx"
	EmailAlias    *string `json:"email_alias,omitempty"`    // 邮箱别名, 示例值: "xxx@xx.xxx"
}

// CreateMailUserMailboxAliasResp ...
type CreateMailUserMailboxAliasResp struct {
	UserMailboxAlias *CreateMailUserMailboxAliasRespUserMailboxAlias `json:"user_mailbox_alias,omitempty"` // 用户邮箱别名
}

// CreateMailUserMailboxAliasRespUserMailboxAlias ...
type CreateMailUserMailboxAliasRespUserMailboxAlias struct {
	PrimaryEmail string `json:"primary_email,omitempty"` // 主邮箱地址
	EmailAlias   string `json:"email_alias,omitempty"`   // 邮箱别名
}

// createMailUserMailboxAliasResp ...
type createMailUserMailboxAliasResp struct {
	Code int64                           `json:"code,omitempty"` // 错误码, 非 0 表示失败
	Msg  string                          `json:"msg,omitempty"`  // 错误描述
	Data *CreateMailUserMailboxAliasResp `json:"data,omitempty"`
}
