// Code generated by lark_sdk_gen. DO NOT EDIT.
/**
 * Copyright 2022 chyroc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package lark

import (
	"context"
)

// CreateMessagePin Pin一条指定的消息。
//
// 注意事项:
// - 需要开启[机器人能力](https://open.feishu.cn/document/uAjLw4CM/ugTN1YjL4UTN24CO1UjN/trouble-shooting/how-to-enable-bot-ability)
// - Pin消息时, 机器人必须在对应的群组中
// - 若消息已经被Pin, 返回该Pin的操作信息
// - 不能Pin一条对操作者不可见的消息
// - 对同一条消息的Pin操作不能超过[5 QPS]
//
// doc: https://open.feishu.cn/document/uAjLw4CM/ukTMukTMukTM/reference/im-v1/pin/create
func (r *MessageService) CreateMessagePin(ctx context.Context, request *CreateMessagePinReq, options ...MethodOptionFunc) (*CreateMessagePinResp, *Response, error) {
	if r.cli.mock.mockMessageCreateMessagePin != nil {
		r.cli.log(ctx, LogLevelDebug, "[lark] Message#CreateMessagePin mock enable")
		return r.cli.mock.mockMessageCreateMessagePin(ctx, request, options...)
	}

	req := &RawRequestReq{
		Scope:                 "Message",
		API:                   "CreateMessagePin",
		Method:                "POST",
		URL:                   r.cli.openBaseURL + "/open-apis/im/v1/pins",
		Body:                  request,
		MethodOption:          newMethodOption(options),
		NeedTenantAccessToken: true,
		NeedUserAccessToken:   true,
	}
	resp := new(createMessagePinResp)

	response, err := r.cli.RawRequest(ctx, req, resp)
	return resp.Data, response, err
}

// MockMessageCreateMessagePin mock MessageCreateMessagePin method
func (r *Mock) MockMessageCreateMessagePin(f func(ctx context.Context, request *CreateMessagePinReq, options ...MethodOptionFunc) (*CreateMessagePinResp, *Response, error)) {
	r.mockMessageCreateMessagePin = f
}

// UnMockMessageCreateMessagePin un-mock MessageCreateMessagePin method
func (r *Mock) UnMockMessageCreateMessagePin() {
	r.mockMessageCreateMessagePin = nil
}

// CreateMessagePinReq ...
type CreateMessagePinReq struct {
	MessageID string `json:"message_id,omitempty"` // 待Pin的消息ID, 详情参见[消息ID说明](https://open.feishu.cn/document/uAjLw4CM/ukTMukTMukTM/reference/im-v1/message/intro#ac79c1c2), 示例值: "om_dc13264520392913993dd051dba21dcf"
}

// CreateMessagePinResp ...
type CreateMessagePinResp struct {
	Pin *CreateMessagePinRespPin `json:"pin,omitempty"` // Pin的操作信息
}

// CreateMessagePinRespPin ...
type CreateMessagePinRespPin struct {
	MessageID      string `json:"message_id,omitempty"`       // Pin的消息ID
	ChatID         string `json:"chat_id,omitempty"`          // Pin消息所在的群聊ID
	OperatorID     string `json:"operator_id,omitempty"`      // Pin的操作人ID
	OperatorIDType IDType `json:"operator_id_type,omitempty"` // Pin的操作人ID类型。当Pin的操作人为用户时, 为[open_id]；当Pin的操作人为机器人时, 为[app_id]
	CreateTime     string `json:"create_time,omitempty"`      // Pin的创建时间（毫秒级时间戳）
}

// createMessagePinResp ...
type createMessagePinResp struct {
	Code int64                 `json:"code,omitempty"` // 错误码, 非 0 表示失败
	Msg  string                `json:"msg,omitempty"`  // 错误描述
	Data *CreateMessagePinResp `json:"data,omitempty"`
}
