// Code generated by lark_sdk_gen. DO NOT EDIT.
/**
 * Copyright 2022 chyroc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package lark

import (
	"github.com/chyroc/lark/internal"
)

// OpenTaskTab 打开任务tab页
//
// 唤起任务tab页，跳转到指定tab。
//
// **什么是「任务」**：[任务](https://www.feishu.cn/hc/zh-CN/articles/798052212434)是一个轻量级的团队任务管理工具，可有效帮助成员：集中管理任务、追踪任务进度、推进团队协作。
//
// doc: https://open.feishu.cn/document/uAjLw4CM/uYjL24iN/applink-protocol/supported-protocol/open-todo/open-the-task-tab-page
func (r *AppLinkService) OpenTaskTab(req *OpenTaskTabReq) string {
	return internal.JoinAppLinkURL("https://applink.feishu.cn/client/todo/view", req)
}

// OpenTaskTabReq ...
type OpenTaskTabReq struct {
	Tab string `json:"tab,omitempty"` // String类型, 枚举值包括: `all` 进行中；  `assign_to_me` 由我处理；  `assign_from_me` 我分配的；  `followed`  我关注的；  `completed` 已完成
}
