// Code generated by lark_sdk_gen. DO NOT EDIT.
/**
 * Copyright 2022 chyroc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package test

import (
	"context"
	"fmt"
	"testing"

	"github.com/stretchr/testify/assert"

	"github.com/chyroc/lark"
)

func Test_Auth_Sample_Failed(t *testing.T) {
	as := assert.New(t)

	t.Run("request failed", func(t *testing.T) {
		cli := AppAllPermission.Ins()
		cli.Mock().MockGetTenantAccessToken(mockGetTenantAccessTokenFailed)
		cli.Mock().MockGetAppAccessToken(mockGetTenantAccessTokenFailed)
		moduleCli := cli.Auth

		t.Run("", func(t *testing.T) {

			_, _, err := moduleCli.GetAccessToken(ctx, &lark.GetAccessTokenReq{})
			as.NotNil(err)
			as.Equal(err.Error(), "failed")
		})

	})

	t.Run("request mock failed", func(t *testing.T) {
		cli := AppAllPermission.Ins()
		moduleCli := cli.Auth

		t.Run("", func(t *testing.T) {

			cli.Mock().MockAuthResendAppTicket(func(ctx context.Context, request *lark.ResendAppTicketReq, options ...lark.MethodOptionFunc) (*lark.ResendAppTicketResp, *lark.Response, error) {
				return nil, nil, fmt.Errorf("mock-failed")
			})
			defer cli.Mock().UnMockAuthResendAppTicket()

			_, _, err := moduleCli.ResendAppTicket(ctx, &lark.ResendAppTicketReq{})
			as.NotNil(err)
			as.Equal(err.Error(), "mock-failed")
		})

		t.Run("", func(t *testing.T) {

			cli.Mock().MockAuthGetAccessToken(func(ctx context.Context, request *lark.GetAccessTokenReq, options ...lark.MethodOptionFunc) (*lark.GetAccessTokenResp, *lark.Response, error) {
				return nil, nil, fmt.Errorf("mock-failed")
			})
			defer cli.Mock().UnMockAuthGetAccessToken()

			_, _, err := moduleCli.GetAccessToken(ctx, &lark.GetAccessTokenReq{})
			as.NotNil(err)
			as.Equal(err.Error(), "mock-failed")
		})

		t.Run("", func(t *testing.T) {

			cli.Mock().MockAuthRefreshAccessToken(func(ctx context.Context, request *lark.RefreshAccessTokenReq, options ...lark.MethodOptionFunc) (*lark.RefreshAccessTokenResp, *lark.Response, error) {
				return nil, nil, fmt.Errorf("mock-failed")
			})
			defer cli.Mock().UnMockAuthRefreshAccessToken()

			_, _, err := moduleCli.RefreshAccessToken(ctx, &lark.RefreshAccessTokenReq{})
			as.NotNil(err)
			as.Equal(err.Error(), "mock-failed")
		})

		t.Run("", func(t *testing.T) {

			cli.Mock().MockAuthGetUserInfo(func(ctx context.Context, request *lark.GetUserInfoReq, options ...lark.MethodOptionFunc) (*lark.GetUserInfoResp, *lark.Response, error) {
				return nil, nil, fmt.Errorf("mock-failed")
			})
			defer cli.Mock().UnMockAuthGetUserInfo()

			_, _, err := moduleCli.GetUserInfo(ctx, &lark.GetUserInfoReq{})
			as.NotNil(err)
			as.Equal(err.Error(), "mock-failed")
		})

	})

	t.Run("response is failed", func(t *testing.T) {
		cli := AppNoPermission.Ins()
		moduleCli := cli.Auth

		t.Run("", func(t *testing.T) {

			_, _, err := moduleCli.ResendAppTicket(ctx, &lark.ResendAppTicketReq{})
			as.NotNil(err)
			as.True(lark.GetErrorCode(err) > 0, fmt.Sprintf("need get lark err, but get %s", err))
		})

		t.Run("", func(t *testing.T) {

			_, _, err := moduleCli.GetAccessToken(ctx, &lark.GetAccessTokenReq{})
			as.NotNil(err)
			as.True(lark.GetErrorCode(err) > 0, fmt.Sprintf("need get lark err, but get %s", err))
		})

		t.Run("", func(t *testing.T) {

			_, _, err := moduleCli.RefreshAccessToken(ctx, &lark.RefreshAccessTokenReq{})
			as.NotNil(err)
			as.True(lark.GetErrorCode(err) > 0, fmt.Sprintf("need get lark err, but get %s", err))
		})

		t.Run("", func(t *testing.T) {

			_, _, err := moduleCli.GetUserInfo(ctx, &lark.GetUserInfoReq{})
			as.NotNil(err)
			as.True(lark.GetErrorCode(err) > 0, fmt.Sprintf("need get lark err, but get %s", err))
		})

	})

	t.Run("fake request is failed", func(t *testing.T) {
		cli := AppAllPermission.Ins()
		moduleCli := cli.Auth
		cli.Mock().MockRawRequest(func(ctx context.Context, req *lark.RawRequestReq, resp interface{}) (response *lark.Response, err error) {
			return nil, fmt.Errorf("fake raw request")
		})

		t.Run("", func(t *testing.T) {

			_, _, err := moduleCli.ResendAppTicket(ctx, &lark.ResendAppTicketReq{})
			as.NotNil(err)
			as.Equal("fake raw request", err.Error())
		})

		t.Run("", func(t *testing.T) {

			_, _, err := moduleCli.GetAccessToken(ctx, &lark.GetAccessTokenReq{})
			as.NotNil(err)
			as.Equal("fake raw request", err.Error())
		})

		t.Run("", func(t *testing.T) {

			_, _, err := moduleCli.RefreshAccessToken(ctx, &lark.RefreshAccessTokenReq{})
			as.NotNil(err)
			as.Equal("fake raw request", err.Error())
		})

		t.Run("", func(t *testing.T) {

			_, _, err := moduleCli.GetUserInfo(ctx, &lark.GetUserInfoReq{})
			as.NotNil(err)
			as.Equal("fake raw request", err.Error())
		})

	})
}
